【hdu 2955】Robberies

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 21981 Accepted Submission(s): 8121

Problem Description
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.

For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

Sample Input
3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

Sample Output
2
4
6

【题目链接】:http://acm.hdu.edu.cn/showproblem.php?pid=2955

【题解】

这题的思维量挺大的吧。
首先要把被抓的概率转化为安全的概率.因为求几个事件的被抓概率并不好求。
而安全的概率则可以直接乘在一起;
然后设f[i]表示偷到钱数为i时,安全的概率最大是多少;
f[0]=1,其他一开始都为0;
(0表示什么都不偷,那肯定是百分百安全的);
然后f[j] = max(f[j],f[j-m[i]]*(1-p[i]));
(按照01背包的方式更新就好);
(每个银行有抢和不抢两种选择);
然后从大到下枚举j,找到最大的满足f[j]>(1-P)的j,然后输出就好.

【完整代码】

#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e2+10;

int n;
int m[MAXN];
double p[MAXN],P,f[MAXN*MAXN];

int main()
{
    //freopen("F:\rush.txt","r",stdin);
    int T;
    scanf("%d",&T);
    while (T--)
    {
        scanf("%lf%d",&P,&n);
        int sum = 0;
        for (int i = 1;i <= n;i++)
            scanf("%d%lf",&m[i],&p[i]),sum+=m[i];
        for (int i = 1;i <= sum;i++)
            f[i] = 0;
        f[0] = 1;
        for (int i = 1;i <= n;i++)
            for (int j = sum;j >= 0;j--)
                f[j] = max(f[j],f[j-m[i]]*(1-p[i]));
        int ans = 0;
        for (int i = sum;i >= 1;i--)
            if (f[i]>(1-P))
            {
                ans = i;
                break;
            }
        cout << ans << endl;
    }
    return 0;
}
原文地址:https://www.cnblogs.com/AWCXV/p/7626705.html